/* TODO: Un dump  la fin de l'arborescence 		*/
/* 	 un masque des champs de flags, etc ... 	*/
/*	 Essayer de voir pour sauver dans un fichier 	*/
/*	 Essayer de voir pour effacer l'arborescence   */
/*	 l'aide d'un bouton				*/

#include "gui.h"

typedef struct gtk_paquet
{
  GtkWidget *intitule;		/* IP,TCP,UDP,ARP */
  GtkWidget **donnees;		/* details */
  char *info;
}
gtk_paquet;

/* Crer un tree item avec comme intitule "label data", ou data */
/* est convertit si convert == 1. Place cet item dans arbre et  */
/* le retourne							*/
/* voir gdk_input_add() pour que l'affichage ne se fige pas.	*/
GtkWidget *
create_tree_item (char *label, char *data, GtkWidget * arbre, int convert)
{
  GtkWidget *elt;
  char *temp, *temp2;
#ifdef DEBUG  
  printf ("%s %s ->", label, data);
  fflush(stdout);
#endif  
  if (data == NULL)
    {
#ifdef DEBUG      
      printf ("%snot yet implemented\n", label);
#endif      
      temp = (char *) malloc (sizeof (char) * (strlen (label) + 2));
      sprintf (temp, "%s?", label);
    }
  else
    {
      if (convert)
	{
	  temp2 = malloc (sizeof (char) * 10);
	  sprintf (temp2, "%ld", strtol (data, NULL, 16));
	}
      else
	temp2 = data;
      temp =
	(char *) malloc (sizeof (char) *
			 (strlen (label) + strlen (temp2) + 1));
      sprintf (temp, "%s%s", label, temp2);
    }
#ifdef DEBUG    
  printf ("%s %s\n", label, temp2);
#endif  
  elt = gtk_tree_item_new_with_label (temp);
  gtk_widget_show (elt);
  gtk_tree_append (GTK_TREE (arbre), elt);
  free (temp);
  return (elt);
}

GtkWidget *
packet_to_subtree (char *packet, my_interface * itf, GtkWidget * root)
{
  GtkWidget *tree, *elt, *final_elt;
  char *temp;
  struct in_addr *in1, *in2;
  in1 = (struct in_addr *) malloc (sizeof (struct in_addr));
  in2 = (struct in_addr *) malloc (sizeof (struct in_addr));
  if (itf->mypacket.sll_protocol == htons (ETH_P_ARP))	/* C de l'ARP */
    {
      myarp *pkt = arp_parser (packet);
      temp = malloc (((strlen (pkt->ether_src) * 2) + 8) * sizeof (char));
      sprintf (temp, "ARP: %s->%s", pkt->ether_src, pkt->ether_dest);
      final_elt = gtk_tree_item_new_with_label (temp);
      gtk_tree_append (GTK_TREE (root), final_elt);
      gtk_widget_show (final_elt);
      tree = gtk_tree_new ();
      gtk_tree_item_set_subtree (GTK_TREE_ITEM (final_elt), tree);
      /* Cration des lments 1  1 */
      in1->s_addr = strtol (pkt->proto_addr_src, NULL, 16);
      in2->s_addr = strtol (pkt->proto_addr_dest, NULL, 16);
      create_tree_item ("Type: ", arp_type (pkt->opcode), tree, 0);
      create_tree_item ("IP source: ", inet_ntoa (*in1), tree, 0);
      create_tree_item ("IP destination: ", inet_ntoa (*in2), tree, 0);
      return (final_elt);
    }
  else if (itf->mypacket.sll_protocol == htons (ETH_P_IP))/* C de l'IP */
    {
      int proto;
      struct in_addr *in1, *in2;
      char *ip;
      GtkWidget *subtree;
      myip *pkt = ip_parser (packet);
      in1 = (struct in_addr *) malloc (sizeof (struct in_addr));
      in2 = (struct in_addr *) malloc (sizeof (struct in_addr));
      in1->s_addr = strtol (pkt->ip_src, NULL, 16);
      in2->s_addr = strtol (pkt->ip_dest, NULL, 16);
      ip = (char *) malloc (sizeof (char) * 15);
      proto = strtol (pkt->proto, NULL, 16);
      temp = (char *) malloc (sizeof (char) * 80);
      strcpy (ip, inet_ntoa (*in1));
      sprintf (temp, "%s->%s", ip, inet_ntoa (*in2));
      switch (proto)
	{
	case 6:
	  final_elt = create_tree_item ("IP/TCP: ", temp, root, 0);
	  break;
	case 17:
	  final_elt = create_tree_item ("IP/UDP: ", temp, root, 0);
	  break;
	case 1:
	  final_elt = create_tree_item ("IP/ICMP: ", temp, root, 0);
	  break;
	default:
	  final_elt = create_tree_item ("IP/????: ", temp, root, 0);
	  break;
	}
      tree = gtk_tree_new ();
      gtk_tree_item_set_subtree (GTK_TREE_ITEM (final_elt), tree);
      elt = gtk_tree_item_new_with_label ("Header IP");
      gtk_widget_show (elt);
      gtk_tree_append (GTK_TREE (tree), elt);
      /* Partie d'affichage IP */
      subtree = gtk_tree_new ();
      create_tree_item ("IP source: ", inet_ntoa (*in1), subtree, 0);
      create_tree_item ("IP destination: ", inet_ntoa (*in2), subtree, 0);
      /*
      create_tree_item ("Version: ",pkt->version,subtree,0);
      create_tree_item ("Type de service: ",pkt->tos,subtree,0);	
      create_tree_item ("LET en mot de 32 bit: ",pkt->let,subtree,0);
      */
      create_tree_item ("Longueur du paquet: ", pkt->len, subtree, 1);
      create_tree_item ("ID: ", pkt->id, subtree, 0);
      create_tree_item ("TTL: ", pkt->ttl, subtree, 1);
      create_tree_item ("Protocole: ", getprotobyid(pkt->proto), subtree, 0);
      gtk_tree_item_set_subtree (GTK_TREE_ITEM (elt), subtree);
      switch (proto)
	{
	  mytcp *pkt_tcp;
	  myudp *pkt_udp;
	  myicmp *pkt_icmp;
	case 6:
	  pkt_tcp = tcp_parser (packet);
	  elt = gtk_tree_item_new_with_label ("Header TCP:");
	  gtk_widget_show (elt);
	  gtk_tree_append (GTK_TREE (tree), elt);
	  subtree = gtk_tree_new ();
	  create_tree_item ("Port source: ", pkt_tcp->port_src, subtree, 1);
	  create_tree_item ("Port destination: ", pkt_tcp->port_dest, subtree,1);
	  create_tree_item ("N Squence: ", pkt_tcp->sequence, subtree, 0);
	  create_tree_item ("Accuse: ", pkt_tcp->accuse, subtree, 0);
	  create_tree_item ("Fenetre: ", pkt_tcp->fenetre, subtree, 0);
	  create_tree_item ("Checksum: ", pkt_tcp->checksum, subtree, 0);
	  create_tree_item ("Data: ",pkt_tcp->data,subtree,0);
	  gtk_tree_item_set_subtree (GTK_TREE_ITEM (elt), subtree);
	  break;
	case 17:
	  pkt_udp = udp_parser (packet);
	  elt = gtk_tree_item_new_with_label ("Header UDP:");
	  gtk_widget_show (elt);
	  gtk_tree_append (GTK_TREE (tree), elt);
	  subtree = gtk_tree_new ();
	  create_tree_item ("Port source: ", pkt_udp->port_src, subtree, 1);
	  create_tree_item ("Port destination: ", pkt_udp->port_dest, subtree,1);
	  create_tree_item ("Longueur: ", pkt_udp->len, subtree, 1);
	  create_tree_item ("Data: ", pkt_udp->data, subtree, 0);
	  gtk_tree_item_set_subtree (GTK_TREE_ITEM (elt), subtree);
	  break;
	case 1:
	  pkt_icmp = icmp_parser(packet);
	  elt = gtk_tree_item_new_with_label ("Header ICMP:");
	  gtk_widget_show(elt);
	  gtk_tree_append(GTK_TREE(tree),elt);
	  subtree = gtk_tree_new();
	  create_tree_item("Type: ",icmp_type(pkt_icmp->type),subtree,0);
	  create_tree_item("Code: ",pkt_icmp->code,subtree,1);
	  create_tree_item("Checksum: ",pkt_icmp->checksum,subtree,0);
	  create_tree_item("Data: ",pkt_icmp->data,subtree,0);
	  gtk_tree_item_set_subtree(GTK_TREE_ITEM(elt),subtree);
	  break;
	default:
	  elt = gtk_tree_item_new_with_label ("Dump de la partie inconnue");
	  gtk_widget_show (elt);
	  gtk_tree_append(GTK_TREE(tree),elt);
	  break;
	}
      /*elt = create_tree_item ("Dump du paquet en hxadcimal: ", temp, tree, 0);
      subtree = gtk_tree_new();
      temp = malloc(sizeof(packet)*/
      
      return (final_elt);
    }
  else
    {
      /* Paquet exotique: dump */
      final_elt = gtk_tree_item_new_with_label("Paquet exotique");
      return (final_elt);
    }
  return (NULL);

}


/* Cre un arbre et le place dans une scroll windows */
/* retourne l'arbre cre, pas de rappel */
/* TODO: retour d'une structure avec arbre + scroll */
GtkWidget *
create_scroll_with_tree ()
{

  GtkWidget *root;
  root = gtk_tree_new ();
/*	scroll = gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroll),root); */
  return (root);
}


/* Cre une box avec un champ de text et un bouton */
/* si le bouton est press, le text est gris */
/* Fonction de rappel modifiant args */
/* TODO: Grer des arguments par dfauts */
GtkWidget *
create_hbox_with_button_and_text (char *title, char *label,
				  GtkSignalFunc func)
{
  GtkWidget *box, *text, *button, *frame;
  frame = gtk_frame_new (title);
  box = gtk_hbox_new (TRUE, 5);
  button = gtk_check_button_new_with_label (label);
  text = gtk_entry_new_with_max_length (15);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button),TRUE);
  gtk_widget_set_sensitive(text,FALSE);

  gtk_signal_connect (GTK_OBJECT (button), "clicked", func, text);
  gtk_signal_connect (GTK_OBJECT (text), "changed", func, button);
  gtk_box_pack_start_defaults (GTK_BOX (box), button);
  gtk_box_pack_start_defaults (GTK_BOX (box), text);
  gtk_container_add (GTK_CONTAINER (frame), box);
  return (frame);
}



GtkWidget *
create_hbox_with_button_and_spin (char *title, char *label, int value,
				  int adj_max, GtkSignalFunc func)
{
  GtkWidget *box, *spin, *button, *frame;
  GtkObject *adj;
  frame = gtk_frame_new (title);
  box = gtk_hbox_new (TRUE, 5);
  adj = gtk_adjustment_new (value, 0, adj_max, 1, 10, 10);
  spin = gtk_spin_button_new (GTK_ADJUSTMENT (adj), 0.2, 0);
  button = gtk_check_button_new_with_label (label);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button),TRUE);
  gtk_widget_set_sensitive(spin,FALSE);

  gtk_signal_connect (GTK_OBJECT (button), "clicked", func, spin);
  gtk_signal_connect (GTK_OBJECT (spin), "changed", func, button);
  gtk_box_pack_start_defaults (GTK_BOX (box), button);
  gtk_box_pack_start_defaults (GTK_BOX (box), spin);
  gtk_container_add (GTK_CONTAINER (frame), box);
  return (frame);
}

gint
delete_event (GtkWidget * widget, GdkEvent * event, gpointer data)
{
  return (TRUE);
}

/* Cration d'une hbox contenant nos boutons radios */
/* fonction de rappel modifiant la structure args */
/* Renvoie une frame contenant la hbox, etc ... */
/* TODO: verif standard de propret */

GtkWidget *
create_hbox_with_radio_button (char *title, char **label)
{
  int i = 0;
  GtkWidget *box, *radio, *frame;
  GSList *group;
  frame = gtk_frame_new (title);
  box = gtk_hbox_new (TRUE, 5);
  /* Le premier, group = NULL pour initialisation */
  group = NULL;
  while (label[i])
    {
      radio = gtk_radio_button_new_with_label (group, label[i]);
      gtk_signal_connect (GTK_OBJECT (radio), "toggled",
			  (GtkSignalFunc) rappel_radio_button,
			  (void *) atoi (label[i]));
      group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio));
      gtk_box_pack_start_defaults (GTK_BOX (box), radio);
      i++;
    }
  gtk_container_add (GTK_CONTAINER (frame), box);
  return (frame);
}

void
destroy (GtkWidget * widget, gpointer data)
{
  gtk_main_quit ();
}

void rappel_text_interface(GtkWidget *widget, void *rien)
{
	argue->interface =  gtk_entry_get_text (GTK_ENTRY (widget));
}
void
rappel_text_and_button_ip (GtkWidget * widget, GtkWidget * other)
{
  if (GTK_IS_ENTRY (widget))
    {
#ifdef DEBUG
      printf ("entry\n");
#endif
      argue->filtre.ip = inet_addr (gtk_entry_get_text (GTK_ENTRY (widget)));
    }
  else
    {
      if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)))
	{
	  argue->filtre.ip = -1;
	  gtk_widget_set_sensitive (other, FALSE);
	}
      else
	{
	  gtk_widget_set_sensitive (other, TRUE);
	  argue->filtre.ip =
	    inet_addr (gtk_entry_get_text (GTK_ENTRY (other)));
	}
    }
}

void
rappel_spin_and_button_nb_packet (GtkWidget * widget, GtkWidget * other)
{
  if (GTK_IS_SPIN_BUTTON (widget))
    {				/* Cas du spin */
#ifdef DEBUG
      printf ("spin button\n");
#endif
      argue->nb_packet =
	gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (widget));
    }
  else
    {				/* Cas du toggle */
#ifdef DEBUG
      printf ("toggle button\n");
#endif
      if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)))
	{
	  argue->nb_packet = -1;
	  gtk_widget_set_sensitive (other, FALSE);
	}
      else
	{
	  gtk_widget_set_sensitive (other, TRUE);
	  argue->nb_packet =
	    gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (other));
	}
    }
}

void
rappel_spin_and_button_port (GtkWidget * widget, GtkWidget * other)
{
  if (GTK_IS_SPIN_BUTTON (widget))
    {				/* Cas du spin */
#ifdef DEBUG
      printf ("spin button\n");
#endif
      argue->filtre.port =
	gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (widget));
    }
  else
    {				/* Cas du toggle */
#ifdef DEBUG
      printf ("toggle button\n");
#endif
      if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)))
	{
	  argue->filtre.port = -1;
	  gtk_widget_set_sensitive (other, FALSE);
	}
      else
	{
	  gtk_widget_set_sensitive (other, TRUE);
	  argue->filtre.port =
	    gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (other));
	}
    }
}

/* Execute lors du clic sur capture, recupre le nombre de paquet */
void
rappel_button_capture (GtkWidget * widget, GtkWidget * arbre)
{
  int captured = 0, len, len_struct;
  char buffer[2048];
  GtkWidget *temp;
  if (init (my_if, argue) < 0)
    {
      printf ("Verifiez que vous etes bien le root !\n");
      return;
    }
  else
    {				/* Let's sniff ... */
      len_struct = sizeof (struct sockaddr_ll);
      while (captured != argue->nb_packet)
	{
	  printf ("Reception ...\n");
	  len =
	    recvfrom (my_if->sock, &buffer, 2048, 0,
		      (struct sockaddr *) &(my_if->mypacket), &len_struct);
	  if (len > 1)
	    {
	      printf ("1 paquets (%i octets) recu ...", len);
	      if (filtre (buffer, argue))
		{
		  printf (" Repondant  nos critres\n");
		  captured++;
		  /* La on l'affiche */
		  temp = packet_to_subtree (buffer, my_if, arbre);
		}
	      else
		printf (" Ne repondant pas  nos critres\n");
	    }
	}
    }
}

/* Execute lors du choix du nivo d'info */
void
rappel_radio_button (GtkWidget * widget, int nivo)
{
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)))
    {
      argue->nivo_info = nivo;
      printf ("On detaillera au nivo %i\n", argue->nivo_info);
    }
}
