#include <unistd.h>
#include <stdlib.h>
#include <netdb.h>


char *
getprotobyid (char *id)
{
  struct protoent *proto;
  if(!(proto = getprotobynumber(strtol(id,NULL,16)))) 
    return("Inconnu");
  else
    return(proto->p_name);
}

int 
getprotoid( char *name)
{
  struct protoent *proto;
  if(!(proto = getprotobyname(name)))
    return(0);
  else
    return(proto->p_proto);
}

char *arp_type(char *opcode)
{
  switch(strtol(opcode,NULL,16))
  {
    case 1:
      return("ARPOP_REQUEST");
      break;
    case 2:
      return("ARPOP_REPLY");
      break;
    case 3:
      return("ARPOP_RREQUEST");
      break;
    case 4:
      return("ARPOP_RREPLY");
      break;
  }
  return(NULL);
}  

char *icmp_type(char *code)
{
  switch(strtol(code,NULL,16))
  {
    case 0:
      return("Echo Reply");
      break;
    case 3:
      return("Destination Unreachable");
      break;
    case 4:
      return("Source Quench");
      break;
    case 5:
      return("Redirect");
      break;
    case 8:
      return("Echo");
      break;
    case 11:
      return("Time Exceeded");
      break;
    case 12:
      return("Parameter Problem");
      break;
    case 13:
      return("Timestamp");
      break;
    case 14:
      return("Timestamp Reply");
      break;
    default:
      return("Code non rfrenc dans le RFC ( voir RFC777 )");
      break;
  }
  return(NULL);
}  


char *
getpkttypebyid (int id)
{
  switch (id)
    {

    case (0):
      return ("PACKET_HOST");
      break;
    case (1):
      return ("PACKET_BROADCAST");
      break;
    case (2):
      return ("PACKET_MULTICAST");
      break;
    case (3):
      return ("PACKET_OTHERHOST");
      break;
    case (4):
      return ("PACKET_OUTGOING");
      break;
    default:
      return ("PACKET_UNKNOW");
    }
}
